//
//  AppDelegate.swift
//  Vendoo
//
//  Created by Okechi Onyeje on 5/22/16.
//  Copyright © 2016 Okechi Onyeje. All rights reserved.
//

import UIKit
import Firebase
import OAuthSwift
import FBSDKCoreKit
import FBSDKLoginKit

@UIApplicationMain
class AppDelegate: UIResponder, UIApplicationDelegate {

    var window: UIWindow?


    func application(application: UIApplication, didFinishLaunchingWithOptions launchOptions: [NSObject: AnyObject]?) -> Bool {
        
        //configures firebase for app use
        FIRApp.configure()
        
        // Override point for customization after application launch.
        self.window = UIWindow(frame: UIScreen.mainScreen().bounds)
        
        let storyboard = UIStoryboard(name: "Main", bundle: nil)
        let view: UIViewController!
        if NSUserDefaults.standardUserDefaults().boolForKey("signedIn"){
            view = storyboard.instantiateViewControllerWithIdentifier("SignInViewController")
        }else {
            view = storyboard.instantiateViewControllerWithIdentifier("SignUp")
        }
        
        
        self.window?.rootViewController = view
        self.window?.makeKeyAndVisible()
        
        //configure facebook for app
        return FBSDKApplicationDelegate.sharedInstance().application(application, didFinishLaunchingWithOptions: launchOptions)
        
    }

    func applicationWillResignActive(application: UIApplication) {
        // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
        // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
    }

    func applicationDidEnterBackground(application: UIApplication) {
        // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
        // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
    }

    func applicationWillEnterForeground(application: UIApplication) {
        // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
    }

    func applicationDidBecomeActive(application: UIApplication) {
        // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
    }

    func applicationWillTerminate(application: UIApplication) {
        // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
    }


}


//MARK: -
extension AppDelegate {

    func application(app: UIApplication, openURL url: NSURL, options: [String : AnyObject]) -> Bool {
        if (url.host == "oauth-callback") {
            print(url)
            let components = NSURLComponents(URL: url, resolvingAgainstBaseURL: false)
            var token:String?
            var verifier:String?
            var secret:String?
            if let queryItems = components?.queryItems
            {
                for queryItem in queryItems
                {
                    if (queryItem.name.lowercaseString == "oauth_token")
                    {
                        token = queryItem.value
                        print(token!)
                        
                    }
                    if (queryItem.name.lowercaseString == "oauth_verifier")
                    {
                        verifier = queryItem.value
                        print(verifier!)
                        
                    }
                    if (queryItem.name.lowercaseString == "oauth_secret"){
                        verifier = queryItem.value
                        print(secret!)
                    }
                }
            }
            OAuthSwift.handleOpenURL(url)
        }
        return true
    }
    
    func application(application: UIApplication, openURL url: NSURL, sourceApplication: String?, annotation: AnyObject) -> Bool {
        return FBSDKApplicationDelegate.sharedInstance().application(application, openURL: url, sourceApplication: sourceApplication, annotation: annotation)
    }
}

